
// INCLUDES ///////////////////////////////////////////////

#define INITGUID

#define WIN32_LEAN_AND_MEAN  

#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <iostream> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>

#include <ddraw.h>  // directX includes
#include <dsound.h>
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicc.h>
#include <dmusicf.h>
#include <dinput.h>
#include "T3DLIB1.h" // game library includes
#include "T3DLIB2.h"
#include "T3DLIB3.h"

using namespace std;

//#include "mono.h"

// DEFINES ////////////////////////////////////////////////

#define PLAYER_FACE    0
int WeaponUpgradeLevel = 1;
int GotMap = 0;

// mathematical defines
CONST float FRICTION = float(0.1);

// defines for windows 
#define WINDOW_CLASS_NAME "WINCLASS"  // class name

#define WINDOW_WIDTH    640            // size of window viewport
#define WINDOW_HEIGHT   480

// size of universe
#define UNIVERSE_MIN_X   (-8000)
#define UNIVERSE_MAX_X   (8000)
#define UNIVERSE_MIN_Y   (-8000)
#define UNIVERSE_MAX_Y   (8000)

// weapons defines
#define MAX_PLASMA         128   // max number of plasma pulses
#define PLASMA_SPEED_MIRANU 24
#define PLASMA_SPEED_KRAIT 22
#define PLASMA_SPEED_ZIDEGAR 20
#define PLASMA_SPEED_LAZIRA 18
#define PLASMA_SPEED_ARADA 18
#define PLASMA_SPEED       16   // pixels/sec of plasma pulse
#define PLASMA_SPEED_SLOW  12   

#define PLASMA_STATE_OFF   0   // this plasma is dead or off
#define PLASMA_STATE_ON    1   // this one is alive and in flight
#define PLASMA_RANGE_1     30  // type 1 plasma disruptor

#define PLASMA_ANIM_PLAYER     0  // a plasma torpedeo from player
#define PLASMA_ANIM_ENEMY      1  // a plasma torpedeo from any enemy

// asteroid field defines
#define MAX_ROCKS             300
#define ROCK_STATE_OFF        0   // this rock is dead or off
#define ROCK_STATE_ON         1   // this one is alive and in flight

#define ROCK_LARGE            0   // sizes of rock
#define ROCK_MEDIUM           1
#define ROCK_SMALL            2

// explosion defines 
#define MAX_BURSTS            8
#define BURST_STATE_OFF       0   // this burst is dead or off
#define BURST_STATE_ON        1   // this one is alive

// defines for player states
#define PLAYER_STATE_DEAD           0
#define PLAYER_STATE_DYING          1
#define PLAYER_STATE_INVINCIBLE     2
#define PLAYER_STATE_ALIVE          3
#define PLAYER_STATE_GAME_WON		4
#define PLAYER_REGEN_COUNT          100 // click before regenerating

#define CRESCENT_INDEX_DIR            3 // index of direction var

#define MAX_PLAYER_SPEED            16

// sound id's
#define MAX_FIRE_SOUNDS       8
#define MAX_EXPL_SOUNDS       8

// defines for aradas
#define MAX_ARADAS            20

#define ARADA_RANGE_RING       4000 // distance from player arada will be created at

#define MAX_ARADA_DAMAGE       50
#define INDEX_ARADA_DAMAGE     2  // damage level of arada
#define INDEX_ARADA_DIR        3  // direction of ship 

// life state for aradas
#define ARADA_STATE_DEAD        0
#define ARADA_STATE_ALIVE       1
#define ARADA_STATE_DAMAGED     2  
#define ARADA_STATE_DYING       3

#define MAX_ARADA_VELOCITY        12  
#define MIN_ARADA_TRACKING_DIST   1000
#define ARADA_MIN_ATTACK_RANGE  500

// defines for laziras
#define MAX_LAZIRAS            15

#define LAZIRA_RANGE_RING       5000 // distance from player lazira will be created at

#define MAX_LAZIRA_DAMAGE       100
#define INDEX_LAZIRA_DAMAGE     2  // damage level of lazira
#define INDEX_LAZIRA_DIR        3  // direction of ship 

// life state for laziras
#define LAZIRA_STATE_DEAD        0
#define LAZIRA_STATE_ALIVE       1
#define LAZIRA_STATE_DAMAGED     2  
#define LAZIRA_STATE_DYING       3

#define MAX_LAZIRA_VELOCITY        14  
#define MIN_LAZIRA_TRACKING_DIST   2000
#define LAZIRA_MIN_ATTACK_RANGE  800

// defines for zidegars
#define MAX_ZIDEGARS            10

#define ZIDEGAR_RANGE_RING       5000 // distance from player zidegar will be created at

#define MAX_ZIDEGAR_DAMAGE       200
#define INDEX_ZIDEGAR_DAMAGE     2  // damage level of zidegar
#define INDEX_ZIDEGAR_DIR        3  // direction of ship 

// life state for zidegars
#define ZIDEGAR_STATE_DEAD        0
#define ZIDEGAR_STATE_ALIVE       1
#define ZIDEGAR_STATE_DAMAGED     2  
#define ZIDEGAR_STATE_DYING       3

#define MAX_ZIDEGAR_VELOCITY        16  
#define MIN_ZIDEGAR_TRACKING_DIST   2500
#define ZIDEGAR_MIN_ATTACK_RANGE  1000

// defines for kraits
#define MAX_KRAITS            5

#define KRAIT_RANGE_RING       5000 // distance from player krait will be created at

#define MAX_KRAIT_DAMAGE       400
#define INDEX_KRAIT_DAMAGE     2  // damage level of krait
#define INDEX_KRAIT_DIR        3  // direction of ship 

// life state for kraits
#define KRAIT_STATE_DEAD        0
#define KRAIT_STATE_ALIVE       1
#define KRAIT_STATE_DAMAGED     2  
#define KRAIT_STATE_DYING       3

#define MAX_KRAIT_VELOCITY        18  
#define MIN_KRAIT_TRACKING_DIST   2500
#define KRAIT_MIN_ATTACK_RANGE  1000

// defines for miranu
#define MAX_MIRANU            1

#define MIRANU_RANGE_RING       5000 // distance from player miranu will be created at

#define MAX_MIRANU_DAMAGE       1000
#define INDEX_MIRANU_DAMAGE     2  // damage level of miranu
#define INDEX_MIRANU_DIR        3  // direction of ship 

// life state for kraits
#define MIRANU_STATE_DEAD        0
#define MIRANU_STATE_ALIVE       1
#define MIRANU_STATE_DAMAGED     2  
#define MIRANU_STATE_DYING       3

#define MAX_MIRANU_VELOCITY        18  
#define MIN_MIRANU_TRACKING_DIST   2500
#define MIRANU_MIN_ATTACK_RANGE  1000

// defines for powerups
#define POWERUP_TYPE_AMMO       0
#define POWERUP_TYPE_SHLD       1
#define POWERUP_TYPE_MAP		2

#define POWERUP_STATE_DEAD      0
#define POWERUP_STATE_ALIVE     1
#define MAX_POWERUPS            16
#define INDEX_POWERUP_TYPE      0


// defines for stations
#define MAX_STATIONS           1

// life state for stations
#define STATION_STATE_DEAD       0
#define STATION_STATE_ALIVE      1
#define STATION_STATE_DAMAGED    2  
#define STATION_STATE_DYING      3

#define STATION_SHIELDS_ANIM_ON  0  // animations for shields
#define STATION_SHIELDS_ANIM_OFF 1 

#define STATION_RANGE_RING       300

#define INDEX_STATION_DAMAGE     2  // tracks the current damage of station
#define MAX_STATION_DAMAGE      25000

#define STATION_MIN_UPLINK_DISTANCE  150

// defines for the star field

#define MAX_STARS                256   // number of stars in universe

#define STAR_PLANE_0             0    // far plane
#define STAR_PLANE_1             1    // near plane
#define STAR_PLANE_2             2

#define STAR_COLOR_0             8    // color of farthest star plane
#define STAR_COLOR_1             7
#define STAR_COLOR_2             15   // color of nearest star plane


// defines for particle system
#define PARTICLE_STATE_DEAD               0
#define PARTICLE_STATE_ALIVE              1

// types of particles
#define PARTICLE_TYPE_FLICKER             0
#define PARTICLE_TYPE_FADE                1 

// color of particle
#define PARTICLE_COLOR_RED                0
#define PARTICLE_COLOR_GREEN              1
#define PARTICLE_COLOR_BLUE               2
#define PARTICLE_COLOR_WHITE              3

#define MAX_PARTICLES                     128

// color ranges
#define COLOR_RED_START                   32
#define COLOR_RED_END                     47

#define COLOR_GREEN_START                 96
#define COLOR_GREEN_END                   111

#define COLOR_BLUE_START                  144
#define COLOR_BLUE_END                    159

#define COLOR_WHITE_START                 16
#define COLOR_WHITE_END                   31

// indices used to access data arrays in BOBs 
#define INDEX_WORLD_X                     8
#define INDEX_WORLD_Y                     9

// defines for the states of the main loop
#define GAME_STATE_INIT                  0
#define GAME_STATE_MENU                  1
#define GAME_STATE_RESTART               2
#define GAME_STATE_RUNNING               3
#define GAME_STATE_UPLINK                4
#define GAME_STATE_EXIT                  5
#define GAME_STATE_WAITING_FOR_EXIT      6
#define GAME_STATE_PAUSED                7

// the menu defines
#define MENU_STATE_MAIN                  0   // main menu state 
#define MENU_STATE_INST                  1   // instructions state
#define MENU_SEL_NEW_GAME                0
#define MENU_SEL_INSTRUCTIONS            1
#define MENU_SEL_EXIT                    2
#define MAX_INSTRUCTION_PAGES            6  

// defines for font
#define FONT_NUM_CHARS         96  // entire character set
#define FONT_WIDTH             12
#define FONT_HEIGHT            12
#define FONT_WIDTH_NEXT_NUM    8
#define FONT_WIDTH_NEXT_LOWER  7
#define FONT_WIDTH_NEXT_UPPER  8

// number of starting objects
#define NUM_ACTIVE_ARADAS			 10
#define NUM_ACTIVE_LAZIRAS			 0
#define NUM_ACTIVE_ZIDEGARS			 0
#define NUM_ACTIVE_STATIONS          1
#define NUM_ACTIVE_KRAITS			 0
#define NUM_ACTIVE_MIRANU			 0	


// PROTOTYPES /////////////////////////////////////////////

// game console
int  Game_Init(void *parms=NULL);
int  Game_Shutdown(void *parms=NULL);
int  Game_Main(void *parms=NULL);
void Game_Reset(void);

// helper functions for game logic
void Draw_Info(void);
void Start_Burst(int x, int y, int width, int height, int xv,int yv);
void Draw_Bursts(void);
void Move_Bursts(void);
void Delete_Bursts(void);
void Init_Bursts(void);
void Reset_Bursts(void);

void Draw_Rocks(void);
void Start_Rock(int x, int y, int size,int xv, int yv);
void Move_Rocks(void);
void Delete_Rocks(void);
void Init_Rocks(void);
void Reset_Rocks(void);


void Draw_Powerups(void);
void Start_Powerup(int type, int x, int y);
void Move_Powerups(void);
void Delete_Powerups(void);
void Init_Powerups(void);
void Reset_Powerups(void);

void Init_Aradas(void);
void Move_Aradas(void);
void Draw_Aradas(void);
void Start_Arada(int override, int x, int y, int dir);
void Reset_Aradas(void);

void Init_Laziras(void);
void Move_Laziras(void);
void Draw_Laziras(void);
void Start_Lazira(int override, int x, int y, int dir);
void Reset_Laziras(void);

void Init_Zidegars(void);
void Move_Zidegars(void);
void Draw_Zidegars(void);
void Start_Zidegar(int override, int x, int y, int dir);
void Reset_Zidegars(void);

void Init_Kraits(void);
void Move_Kraits(void);
void Draw_Kraits(void);
void Start_Krait(int override, int x, int y, int dir);
void Reset_Kraits(void);

void Init_Miranu(void);
void Move_Miranu(void);
void Draw_Miranu(void);
void Start_Miranu(int override, int x, int y, int dir);
void Reset_Miranu(void);

void Fire_Plasma(int x,int y, int xv, int yv, int source);
void Draw_Plasma(void);
void Move_Plasma(void);
void Delete_Plasma(void);
void Init_Plasma(void);
void Reset_Plasma(void);

void Move_Stars(void);
void Draw_Stars(void);
void Init_Stars(void);
void Reset_Stars(void);


void Init_Reset_Particles(void);
void Draw_Particles(void);
void Move_Particles(void);
void Start_Particle(int type, int color, int count, int x, int y, int xv, int yv);
void Start_Particle_Explosion(int type, int color, int count, 
                              int x, int y, int xv, int yv, int num_particles);

void Reset_Particles(void);


void Init_Stations(void);
void Move_Stations(void);
void Draw_Stations(void);
void Start_Station(int override, int x, int y);
void Reset_Stations(void);


void Create_Tables(void);
float Fast_Distance_2D(float x, float y);
void Seed_Rocks(void);
int Load_Player(void);
void Draw_Scanner(void);
int Pad_Name(char *filename, char *extension, char *padstring, int num);

int Copy_Screen(UCHAR *source_bitmap,UCHAR *dest_buffer, int lpitch, int transparent);

void Load_Buttons(void);
void Load_HUD(void);


inline void Copy_Palette(LPPALETTEENTRY dest, LPPALETTEENTRY source)
{ memcpy(dest, source, 256*sizeof(PALETTEENTRY)); }


// TYPES //////////////////////////////////////////////////

// used to contain a single star
typedef struct STAR_TYP
        {
        int x,y;                   // position of star
        UCHAR color;               // color of star
        int plane;                 // plane that star is in

        } STAR, *STAR_PTR;


// a single particle
typedef struct PARTICLE_TYP
        {
        int state;           // state of the particle
        int type;            // type of particle effect
        int x,y;             // world position of particle
        int xv,yv;           // velocity of particle
        int curr_color;      // the current rendering color of particle
        int start_color;     // the start color or range effect
        int end_color;       // the ending color of range effect
        int counter;         // general state transition timer
        int max_count;       // max value for counter

        } PARTICLE, *PARTICLE_PTR;

// MACROS ////////////////////////////////////////////////

// used to compute the min and max of two expresions
#define MIN(a, b)  (((a) < (b)) ? (a) : (b)) 
#define MAX(a, b)  (((a) > (b)) ? (b) : (a)) 

// returns a rand in a range
//#define RAND_RANGE(a,b) ((a)+(rand()%((b)-(a)+1)))

// GLOBALS ////////////////////////////////////////////////

HWND main_window_handle = NULL; // save the window handle
HINSTANCE main_instance = NULL; // save the instance
char buffer[80];                // used to print text

BITMAP_IMAGE background_bmp, menu_bmp; // used to hold backgrounds
BITMAP_IMAGE menu_sel_bmps[3];   // holds the menu selections
BITMAP_IMAGE andre;

BOB crescent;                 // the player 
BOB plasma[MAX_PLASMA];       // plasma pulses
BOB rocks[MAX_ROCKS];         // the asteroids
BOB rock_s, rock_m, rock_l;   // the master templates for surface info
BOB bursts[MAX_BURSTS];       // the explosion bursts
BOB aradas[MAX_ARADAS];		  // the aradas
BOB laziras[MAX_LAZIRAS];
BOB zidegars[MAX_ZIDEGARS];
BOB kraits[MAX_KRAITS];
BOB miranu[MAX_MIRANU];
BOB powerups[MAX_POWERUPS];   // the powerups
BOB stations[MAX_STATIONS];   // the starbase stations
BOB hud;                      // the art for the scanner hud
BOB stationsmall;             // small station bob

int rock_sizes[3] = {96,56,32}; // X,Y dims for scaler

STAR stars[MAX_STARS];          // the star field

PARTICLE particles[MAX_PARTICLES]; // the particles for the particle engine

// player state variables
int player_state       = PLAYER_STATE_ALIVE;
int player_score       = 0;   // the score
int player_threat	   = 0;   // the threat rating
int player_ships       = 3;   // ships left
int player_regen_counter = 0; // used to track when to regen
int player_damage      = 0;   // damage of player
int player_counter     = 0;   // used for state transition tracking
int player_regen_count = 0;   // used to regenerate player
int player_shield_count = 0;  // used to display shields
int ready_counter = 0,        // used to draw a little "get ready"
    ready_state   = 0;

// rate that ships track player
float arada_tracking_rate = 2; 
float lazira_tracking_rate = 3;
float zidegar_tracking_rate = 3;
float krait_tracking_rate = 4;
float miranu_tracking_rate = 5;
 

int station_id = -1,          // uplink station id
    num_stations_destroyed = 0;

int intro_done = 0;           // flags if intro has played already

int game_paused      = 0,
    pause_debounce   = 0,
    huds_on          = 1,
    scanner_on       = 0,
    huds_debounce    = 0,
    scanner_debounce = 0;

// color palettes, so we don't have to reload all the time
PALETTEENTRY         game_palette[256]; // holds the main game palette
PALETTEENTRY         menu_palette[256]; // gee what do you think
PALETTEENTRY         andre_palette[256]; // for me

// positional and state info for player
float player_x=0,
      player_y=0,
	  player_dx=0, 
      player_dy=0, 
	  player_xv=0, 
	  player_yv=0,
      vel = 0;

// these contain the virual cos, sin lookup tables for the 16 sector circle
float cos_look16[16],
      sin_look16[16];

// sound id's
int intro_music_id  = -1,
    main_music_id   = -1,
    ready_id        = -1,
    engines_id      = -1,
    scream_id       = -1,
    game_over_id    = -1,
    deactivate_id   = -1,
    main_menu_id    = -1,
    empty_id        = -1,
    beep0_id             = -1,
    beep1_id             = -1,
    station_blow_id      = -1,
    station_throb_id     = -1,
    ammopu_id            = -1,
    shldpu_id            = -1,
	mappu_id			 = -1,
	jump_id				 = -1;

int expl_ids[MAX_EXPL_SOUNDS] = {-1,-1,-1,-1,-1,-1,-1,-1};
int fire_ids[MAX_FIRE_SOUNDS] = {-1,-1,-1,-1,-1,-1,-1,-1};
int game_state                = GAME_STATE_INIT;   // initial game state
